VERSION 5.00
Object = "{0D452EE1-E08F-101A-852E-02608C4D0BB4}#2.0#0"; "FM20.DLL"
Begin VB.Form frmVis1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00404040&
   Caption         =   "rumint: Text Rainfall"
   ClientHeight    =   8880
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9420
   Icon            =   "frmVis1.frx":0000
   LinkTopic       =   "Form1"
   MinButton       =   0   'False
   ScaleHeight     =   8880
   ScaleWidth      =   9420
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkPrintASCII 
      Caption         =   "Show Strings of Length N"
      Height          =   375
      Left            =   3720
      Style           =   1  'Graphical
      TabIndex        =   6
      Top             =   6600
      Width           =   2055
   End
   Begin VB.CheckBox chkEther 
      Caption         =   "Strip Ether Header"
      Height          =   375
      Left            =   1920
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   6600
      Width           =   1575
   End
   Begin VB.ComboBox cmbVisMode 
      Height          =   315
      ItemData        =   "frmVis1.frx":030A
      Left            =   120
      List            =   "frmVis1.frx":030C
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   6600
      Width           =   1575
   End
   Begin VB.PictureBox picGraphBack 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   6255
      Left            =   2640
      ScaleHeight     =   417
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   177
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   2655
   End
   Begin VB.PictureBox picGraph 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FF00&
      Height          =   6255
      Left            =   0
      ScaleHeight     =   417
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   129
      TabIndex        =   0
      Top             =   0
      Width           =   1935
   End
   Begin VB.Label lblLength 
      Alignment       =   2  'Center
      BackColor       =   &H00C0C0C0&
      Caption         =   "1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5760
      TabIndex        =   4
      Top             =   6600
      Width           =   375
   End
   Begin MSForms.SpinButton spnLength 
      Height          =   375
      Left            =   6120
      TabIndex        =   3
      Top             =   6600
      Width           =   375
      Size            =   "661;661"
      Min             =   1
      Max             =   9
      Position        =   1
      Orientation     =   0
   End
End
Attribute VB_Name = "frmVis1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit
Dim scrollLocation As Long
Dim thumbScrollLocation As Long
Dim startPosition As Long 'display offset
Dim stopPosition As Long 'display offset

Const plotColor = vbGreen

Private Sub incrementScroll(ByRef targetPicGraph As PictureBox, ByVal localScrollLocation As Long, ByVal scrollMax As Long, ByVal increment As Long)
  Dim counter As Long
  
  If scrollLocation < scrollMax - 15 Then
    scrollLocation = scrollLocation + increment
  Else
    scrollLocation = 0
  End If
  
  'I'm sure there is a more elegant way to do this, but for now, it works
  For counter = 0 To 14
    picGraph.Line (0, scrollLocation + counter)-(picGraph.ScaleWidth, scrollLocation + counter), picGraph.BackColor
  Next counter
  
End Sub

'***************** Graphics *********************
Public Sub Plot(ByVal packetNumber, ByRef packetTxt As Variant, ByVal packetLen As Long)
     
  picGraph.ForeColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
  Call calculateDisplayOffsets(picGraph, packetLen, startPosition, stopPosition)
     
  If cmbVisMode.ListIndex = 0 Then Call plotASCII(packetNumber, packetTxt, packetLen, picGraph, scrollLocation, startPosition, stopPosition)
  If cmbVisMode.ListIndex = 1 Then Call plotHex(packetTxt, picGraph, scrollLocation, startPosition, stopPosition)
  If cmbVisMode.ListIndex = 2 Then Call plotDecimal(packetTxt, picGraph, scrollLocation, startPosition, stopPosition)
  
  'Call incrementScroll(picGraph, scrollLocation, picGraph.ScaleHeight, 15)
    
End Sub

'note the default use of by reference
Private Sub calculateDisplayOffsets(ByRef targetPicGraph As PictureBox, _
                                    ByVal localPacketLen As Long, _
                                    startPosition As Long, _
                                    stopPosition As Long)
                                    
  Dim textColumns As Long
  textColumns = targetPicGraph.ScaleWidth / targetPicGraph.TextWidth("S")
  
  If chkEther.value = 1 Then
    startPosition = 14 'strip first 14 bytes
    stopPosition = modLibrary.Min(localPacketLen - 1, textColumns - 1 + 14)
  Else
    startPosition = 0
    stopPosition = modLibrary.Min(localPacketLen - 1, textColumns - 1)
  End If
  
End Sub

'call only if the value is printable ascii
'pass in columns used
Private Function Strings(ByRef packetTxt As Variant, ByVal packetLen As Long, ByVal position As Long) As Long
  Dim length As Long
  Dim counter As Long
  Dim tempChar As String
  Dim tempString As String
  Dim stopPosition As Long
    
  If spnLength.value > (packetLen - position - 1) Then
    'not enough space for string of length N to exist
    Strings = 0 'return from function with null result
  Else
    stopPosition = packetLen - position - 1
  End If
        
  For counter = 0 To stopPosition - 1 'check if string exists
     tempChar = packetTxt(position + counter)
     If (packetTxt(position + counter) >= 32) And (packetTxt(position + counter) < 126) Then
       length = length + 1
     Else
      Exit For 'break loop
     End If
  Next counter
  
  If length >= spnLength.value Then
    Strings = length   'send positive results
  Else
    Strings = 0        'send negative results
  End If
  
End Function

Private Sub plotASCII(ByVal packetNumber As Long, _
                      ByRef packetTxt As Variant, _
                      ByVal packetLen As Long, _
                      ByRef targetPicGraph As PictureBox, _
                      Y As Long, _
                      startPosition As Long, _
                      stopPosition As Long)
  Dim tempString As String
  Dim tempChar As String
  Dim counter As Long
  Dim printedChars As Long
  Dim availableColumns As Long
  Dim currentPosition As Long
  Dim foundStringLen As Long
  
  If (chkPrintASCII.value = 1) Then 'print only strings of length N
    availableColumns = stopPosition - startPosition + 1
    currentPosition = startPosition
    While (printedChars <= availableColumns) And (currentPosition < packetLen)
      'statments
       foundStringLen = Strings(packetTxt, packetLen, currentPosition)
       
       If foundStringLen > 0 Then
         For counter = 1 To foundStringLen
           If (currentPosition + counter - 1) < packetLen Then
             tempChar = Chr(packetTxt(currentPosition + counter - 1))
             tempString = tempString & tempChar
           End If
           printedChars = printedChars + 1
         Next counter
         currentPosition = currentPosition + foundStringLen
       Else
         'increment currentposition
         currentPosition = currentPosition + 1
       End If
    Wend
  Else 'print all characters
    For counter = startPosition To stopPosition
      tempChar = packetTxt(counter)
      If ((Val(tempChar) >= 32) And (Val(tempChar) <= 126)) Then
        tempString = tempString & Chr(Val(tempChar)) 'printable ASCII
      Else
        If Not (chkPrintASCII.value = 1) Then tempString = tempString & "."
      End If
    Next
  End If
  
  If Len(tempString) > 0 Then
    picGraph.CurrentX = 0
    picGraph.CurrentY = scrollLocation
    If packetNumber <> -1 Then tempString = "<" & packetNumber & ">  " & tempString 'indicate packet number
    picGraph.Print tempString
    Call incrementScroll(picGraph, scrollLocation, picGraph.ScaleHeight, 15)
  'Else picGraph.Print "</packet>"
  End If

End Sub

Private Sub plotHex(ByRef packetTxt As Variant, _
                      ByRef targetPicGraph As PictureBox, _
                      Y As Long, _
                      startPosition As Long, _
                      stopPosition As Long)
  Dim tempString As String
  Dim tempChar As String
  Dim counter As Long
  
  For counter = startPosition To stopPosition 'this will overprint the screen as it doesn't count display'd chars
    tempChar = packetTxt(counter)
    tempChar = Hex(tempChar)
    If Len(tempChar) = 2 Then tempChar = tempChar & " "
    If Len(tempChar) = 1 Then tempChar = "0" & tempChar & " "
    tempString = tempString & tempChar & " "
  Next

  picGraph.CurrentX = 0
  picGraph.CurrentY = scrollLocation
  picGraph.Print tempString
  Call incrementScroll(picGraph, scrollLocation, picGraph.ScaleHeight, 15)

End Sub


Private Sub plotDecimal(ByRef packetTxt As Variant, _
                      ByRef targetPicGraph As PictureBox, _
                      Y As Long, _
                      startPosition As Long, _
                      stopPosition As Long)
  Dim tempString As String
  Dim tempChar As String
  Dim counter As Long
  
  For counter = startPosition To stopPosition 'this will overprint the screen as it doesn't count display'd chars
    tempChar = packetTxt(counter)
    tempString = tempString & tempChar & " "
  Next

  picGraph.CurrentX = 0
  picGraph.CurrentY = scrollLocation
  picGraph.Print tempString
  Call incrementScroll(picGraph, scrollLocation, picGraph.ScaleHeight, 15)

End Sub


Public Sub plotThumbnail(ByVal packetLen As Long)
  Dim scaledLength As Long
  
  scaledLength = scaleRange(packetLen, frmMain.picVis(1).ScaleWidth)
  frmMain.picVis(1).Line (0, thumbScrollLocation)-(scaledLength, thumbScrollLocation), vbGreen
  
  If thumbScrollLocation < frmMain.picVis(1).ScaleHeight Then thumbScrollLocation = thumbScrollLocation + 1 Else thumbScrollLocation = 0
    
  'draw the scrolling position line, also serves to erase previous content
  frmMain.picVis(1).Line (0, thumbScrollLocation)-(frmMain.picVis(1).ScaleWidth, thumbScrollLocation), frmMain.picVis(4).BackColor
  
End Sub

'***************** Processing *******************
'This function is used to scale packet values as a fraction of the maximum packet size per RFC (1518 bytes)
Public Function scaleRange(ByVal actualValue As Long, ByVal maxRange As Long) As Long
  If maxRange <= 0 Then
    scaleRange = 0 'returns a zero to avoid division by zero
  Else
    scaleRange = (actualValue / 1518) * maxRange
  End If
End Function




'Private Sub btnLengthDown_Click()
'
'End Sub

'Private Sub btnLengthUp_Click()
 ' If lblLength.Caption <= 9 Then
 '   lblLength.Caption = spnLength.value = spnLength.value
'End Sub

Private Sub Form_Resize()
  Dim meHeight As Long
  
  If Me.Height < 3000 Then Me.Height = 3000
  If Me.Width < 2000 Then Me.Width = 2000
  
  meHeight = Me.Height
  
  'put in code to prevent too small a window size
  
  picGraph.Cls
  picGraph.Left = 0
  picGraph.Top = 0
  
  
  picGraph.Height = Me.Height - 1100
  picGraph.Width = Me.Width
  
  picGraphBack.Cls
  picGraphBack.Top = 0
  picGraphBack.Left = 0
  picGraphBack.Height = Me.Height - 1100
  picGraphBack.Width = Me.Width
  
  cmbVisMode.Top = picGraph.Height + 150
  scrollLocation = 0
  
  chkPrintASCII.Top = picGraph.Height + 280
  chkEther.Top = picGraph.Height + 280
  spnLength.Top = picGraph.Height + 280
  lblLength.Top = picGraph.Height + 280
  
  
  
End Sub

'Double clicking picture box zooms
'when bottom zoom is reached return to top level of zoom
Private Sub picGraph_DblClick()
  If cmbVisMode.ListIndex < (cmbVisMode.ListCount - 1) Then cmbVisMode.ListIndex = cmbVisMode.ListIndex + 1 Else cmbVisMode.ListIndex = 0
  initVisAll
End Sub



'***************** Interface ********************
Private Sub radScroll_Click(Index As Integer)
  initVisAll
End Sub

Private Sub cmbVisMode_Click()
  initVisAll
End Sub

Public Sub initVisAll()
  initVis        'initialize the main visualization
  initVisThumb   'initialize the thumbnail visualization on the toolbar
End Sub

Public Sub clear()
  scrollLocation = 0
  picGraph.Cls
  picGraphBack.Cls
  
  thumbScrollLocation = 0
  frmMain.picVis(1).Cls
End Sub

'initialize the main visualization
Public Sub initVis()
  scrollLocation = 0 'reset current vertical location
  picGraph.Cls       'clear the graphics window
  picGraphBack.Cls   'clear the graphics buffer
  If cmbVisMode.ListIndex = 0 Then
    chkPrintASCII.Visible = True
    lblLength.Visible = True
    spnLength.Visible = True
  Else
    chkPrintASCII.Visible = False
    lblLength.Visible = False
    spnLength.Visible = False
  End If
End Sub

'initialize the thumnail visualization
Public Sub initVisThumb()
  'frmMain.picVis(4).BorderStyle = 0
End Sub

'******************* Form ***********************
Private Sub Form_Unload(Cancel As Integer)
  Call modLibrary.UnloadedForm(Me, frmFilters.vis1)
End Sub

Private Sub Form_Load()
  cmbVisMode.AddItem ("ASCII")
  cmbVisMode.AddItem ("hex")
  cmbVisMode.AddItem ("decimal")
  'cmbVisMode.AddItem ("binary")
  cmbVisMode.ListIndex = 0 'set to first item in the list
  
  spnLength.Visible = False
  lblLength.Visible = False
  lblLength.Caption = spnLength.value
End Sub


Private Sub spnLength_Change()
  lblLength.Caption = spnLength.value
End Sub



Private Sub chkPrintASCII_Click()
  If chkPrintASCII.value = 1 Then
    spnLength.Visible = True
    lblLength.Visible = True
  Else
    spnLength.Visible = False
    lblLength.Visible = False
  End If
End Sub

Public Sub ScreenShot(systemTime As String)
  SavePicture picGraph.Image, App.Path & "\" & systemTime & "_textrainfall.bmp"
End Sub
